"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_code_generator_1 = require("graphql-code-generator");
var documents_glob_1 = require("graphql-code-generator/dist/utils/documents-glob");
var path_1 = require("path");
var graphql_1 = require("graphql");
var watch_fs_1 = require("./watch-fs");
var utils_1 = require("./utils");
var GraphQLCodegenPlugin = /** @class */ (function () {
    function GraphQLCodegenPlugin(options) {
        this.options = options;
        this.pluginName = 'GraphQLCodeGeneratorPlugin';
        this.schemaChecksum = '';
        this.documentsChecksum = '';
        this.outputFile = path_1.resolve(process.cwd(), this.options.out);
        this.schemaLocation = path_1.resolve(process.cwd(), this.options.schema);
    }
    GraphQLCodegenPlugin.prototype.apply = function (compiler) {
        var _this = this;
        compiler.hooks.watchRun.tap(this.pluginName, function () {
            _this.options.exitOnError = false;
        });
        compiler.hooks.afterEnvironment.tap(this.pluginName, function () {
            compiler.watchFileSystem = new watch_fs_1.WatchFileSystem(compiler, compiler.watchFileSystem, _this.outputFile);
        });
        compiler.hooks.beforeCompile.tapPromise(this.pluginName, function () { return _this.generate(); });
        compiler.hooks.afterCompile.tapPromise(this.pluginName, function (compilation) { return _this.includeDocuments(compilation); });
    };
    GraphQLCodegenPlugin.prototype.generate = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.shouldGenerate()];
                    case 1:
                        if (!_a.sent()) return [3 /*break*/, 3];
                        return [4 /*yield*/, graphql_code_generator_1.generate(this.options, true)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    GraphQLCodegenPlugin.prototype.shouldGenerate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.didDocumentsChanged()];
                    case 1:
                        _a = !(_b.sent());
                        if (_a) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.didSchemaChanged()];
                    case 2:
                        _a = !(_b.sent());
                        _b.label = 3;
                    case 3: return [2 /*return*/, _a];
                }
            });
        });
    };
    GraphQLCodegenPlugin.prototype.didDocumentsChanged = function () {
        return __awaiter(this, void 0, void 0, function () {
            var documents, documentsChecksum, changed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.options.args) return [3 /*break*/, 2];
                        return [4 /*yield*/, graphql_code_generator_1.loadDocuments(this.options.args)];
                    case 1:
                        documents = _a.sent();
                        documentsChecksum = utils_1.checksum(documents.map(function (doc) { return graphql_1.print(doc.content); }).join('\n'));
                        changed = documentsChecksum === this.documentsChecksum;
                        this.documentsChecksum = documentsChecksum;
                        return [2 /*return*/, changed];
                    case 2: return [2 /*return*/, false];
                }
            });
        });
    };
    GraphQLCodegenPlugin.prototype.didSchemaChanged = function () {
        return __awaiter(this, void 0, void 0, function () {
            var schemaChecksum, _a, _b, changed;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = utils_1.checksum;
                        _b = graphql_1.printSchema;
                        return [4 /*yield*/, graphql_code_generator_1.loadSchema(this.schemaLocation, this.options)];
                    case 1:
                        schemaChecksum = _a.apply(void 0, [_b.apply(void 0, [_c.sent()])]);
                        changed = schemaChecksum === this.schemaChecksum;
                        this.schemaChecksum = schemaChecksum;
                        return [2 /*return*/, changed];
                }
            });
        });
    };
    GraphQLCodegenPlugin.prototype.includeDocuments = function (compilation) {
        return __awaiter(this, void 0, void 0, function () {
            var documents, found;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        documents = this.options.args;
                        if (!documents) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, documents_glob_1.documentsFromGlobs(documents)];
                    case 1:
                        found = _a.sent();
                        found.filter(function (file) { return !compilation.fileDependencies.has(file); }).map(function (file) { return compilation.fileDependencies.add(file); });
                        return [2 /*return*/];
                }
            });
        });
    };
    return GraphQLCodegenPlugin;
}());
exports.GraphQLCodegenPlugin = GraphQLCodegenPlugin;
//# sourceMappingURL=plugin.js.map